# CryoGrid Vegetation
Created 20210314, CryoGrid branch

This is the modular version of CryoGrid which is based on an object-oriented programming paradigm and described in:

Westermann, S., Langer, M., Boike, J., Heikenfeld, M., Peter, M., Etzelmüller, B., & Krinner, G. (2016). 
Simulating the thermal regime and thaw processes of ice-rich permafrost ground with the land-surface model CryoGrid 3. 
Geosci. Model Dev., 9(2), 523–546. https://doi.org/10.5194/gmd-9-523-2016.

We have coupled CryoGrid to a multilayer canopy model described in:

Bonan, G. B., Patton, E. G., Harman, I. N., Oleson, K. W., Finnigan, J. J., Lu, Y., and Burakowski, E. A.: 
Modeling canopy-induced turbulencein the Earth system: A unified parameterization of turbulent exchange 
within plant canopies and the roughness sublayer (CLM-ml v0),Geoscientific Model Development, 11, 1467–1496, 
https://doi.org/10.5194/gmd-11-1467-2018, 2018



This coupled permafrost vegetation model was first described in the publication: 
Stuenzi, S. M., Boike, J., Cable, W., Herzschuh, U., Kruse, S., Pestryakova, L. A., 
Schneider von Deimling, T., Westermann, S., Zakharov, E. S., 
and Langer, M.: Variability of the surface energy balance in permafrost-underlain boreal forest, 
Biogeosciences, 18, 343–365, https://doi.org/10.5194/bg-18-343-2021, 2021.

The base model code is published here: https://doi.org/10.5281/zenodo.4317106

In this version we have implemented changes to the Here, we add a paramterization for deciduous forest to simulate 
the leafless state of deciduous-dominated regions outside of the short vegetative period in summer. 
This is achieved by allowing for separate leaf area index defined by a rough parameterization of a leaf-on and 
a leaf-off season (10. October - 10. April) based on literature values from Spasskaya Pad \cite{Ohta2001a}. 
Further, more realistic mixed canopy compositions can now be simulated by allowing for a certain percentage of deciduous taxa 
within the simulated forest stand. 
In addition, we add a parameterization for coupling forest density (LAI) to fine root biomass. 
Further, we have implemented a new relationship for phase partitioning of water in frozen soil (freeze curve).


