function [meanW_snowCovered, stdW_snowCovered, minW_snowCovered, maxW_snowCovered, meanW_snowFree, stdW_snowFree, minW_snowFree, maxW_snowFree, maxW, stdW, meanW, minW, maxSnow, maxALT, meanALT, meanT, maxT, minT, meanT_snowCovered, minT_snowCovered, maxT_snowCovered, meanT_snowFree, minT_snowFree, maxT_snowFree, stdT_snowCovered, stdT_snowFree, stdT, PlantWater_av] = read_out_Spasskaya(run_name, out)

load('grid.mat');

result_ground = [];
result_ground.Qh_ground = [];
result_ground.Qe_ground = [];
result_ground.Qh_veg = [];
result_ground.Qe_veg = [];
result_ground.snow = [];

altitudeLowestCell = 400-(10*0.05);
layerThick=[];

layerThick=0.05'; 
timestamp=(0:size(out.STRATIGRAPHY,2));

for i = 1:size(out.STRATIGRAPHY,2)
timestamp=datestr(out.TIMESTAMP);
end

result_ground.x_datetime = datetime(timestamp, 'InputFormat', 'dd-MM-yyyy HH:mm:ss');


depths = [0; cumsum(layerThick)];
depths = -(depths-depths(end,1));
depths = (depths(1:end-1,1)+depths(2:end,1))./2 + altitudeLowestCell;

for i = 1:size(out.STRATIGRAPHY,2)
    [numRows,numCols] = size(out.STRATIGRAPHY{1, i});
    if numRows == 2
    result_ground.stomatalConductanceSun(:,i) = out.VEGETATION{1, i}.STATVAR.mlcanopyinst.gs(1,:,1); 
    result_ground.stomatalConductanceShade(:,i) = out.VEGETATION{1, i}.STATVAR.mlcanopyinst.gs(1,:,2); 
    result_ground.transpiration(:,i) = out.VEGETATION{1, i}.STATVAR.mlcanopyinst.transpiration(:,:);
    result_ground.rn_ground(:,i) = out.VEGETATION{1, i}.STATVAR.mlcanopyinst.rnsoi;
    result_ground.qh_veg(:,i) = out.VEGETATION{1, i}.STATVAR.mlcanopyinst.shsoi;
    result_ground.qe_veg(:,i) = out.VEGETATION{1, i}.STATVAR.mlcanopyinst.lhsoi;
    result_ground.Lout_ground(:,i) = out.STRATIGRAPHY{1, i}{1, 1}.STATVAR.Lout;  %L out at snow    
    result_ground.Lout_CanopyTop(:,i) = out.VEGETATION{1, i}.STATVAR.mlcanopyinst.ircan; % Upward longwave radiation above canopy (W/m2)
    result_ground.Tair_CanopyTop(:,i) = out.VEGETATION{1, i}.STATVAR.mlcanopyinst.taf;   % Air temperature at canopy top (K)
    result_ground.Tair_BelowCanopy(:,i) = out.VEGETATION{1, i}.STATVAR.mlcanopyinst.tair(:,2); % Air temperature below canopy for layer 2 (stem area) (K)
    result_ground.Temp_ground(:,i) = out.STRATIGRAPHY{1, i}{1, 1}.STATVAR.T;
    result_ground.Water_ground(:,i) = out.STRATIGRAPHY{1, i}{1, 1}.STATVAR.water./0.05;
    result_ground.Ice_ground(:,i) = out.STRATIGRAPHY{1, i}{1, 1}.STATVAR.ice./0.05;
    result_ground.snow(:,i) = out.STRATIGRAPHY{1, i}{1, 1}.STATVAR.upperPos-20;
    result_ground.Sin_ground(:,i) = out.VEGETATION{1, i}.STATVAR.flux.swdn(1,1)+out.VEGETATION{1, i}.STATVAR.flux.swdn(1,2);
    result_ground.Lin_ground(:,i) = out.VEGETATION{1, i}.STATVAR.flux.irdn;
    result_ground.Sout_ground(:,i) = out.STRATIGRAPHY{1, i}{1, 1}.STATVAR.Sout;
    elseif numRows == 3
    result_ground.transpiration(:,i) = out.VEGETATION{1, i}.STATVAR.mlcanopyinst.transpiration(:,:);
    result_ground.rn_ground(:,i) = out.VEGETATION{1, i}.STATVAR.mlcanopyinst.rnsoi;
    result_ground.qh_veg(:,i) = out.VEGETATION{1, i}.STATVAR.mlcanopyinst.shsoi;
    result_ground.qe_veg(:,i) = out.VEGETATION{1, i}.STATVAR.mlcanopyinst.lhsoi;
    result_ground.Lout_ground(:,i) = out.STRATIGRAPHY{1, i}{1, 1}.STATVAR.Lout;  %L out at snow    
    result_ground.Lout_CanopyTop(:,i) = out.VEGETATION{1, i}.STATVAR.mlcanopyinst.ircan; % Upward longwave radiation above canopy (W/m2)
    result_ground.Tair_CanopyTop(:,i) = out.VEGETATION{1, i}.STATVAR.mlcanopyinst.taf;   % Air temperature at canopy top (K)
    result_ground.Tair_BelowCanopy(:,i) = out.VEGETATION{1, i}.STATVAR.mlcanopyinst.tair(:,2); % Air temperature below canopy for layer 2 (stem area) (K)
    result_ground.Temp_ground(:,i) = out.STRATIGRAPHY{1, i}{2, 1}.STATVAR.T;
    result_ground.Water_ground(:,i) = out.STRATIGRAPHY{1, i}{2, 1}.STATVAR.water./0.05;
    result_ground.Ice_ground(:,i) = out.STRATIGRAPHY{1, i}{2, 1}.STATVAR.ice./0.05;
    result_ground.snow(:,i) = out.STRATIGRAPHY{1, i}{1, 1}.STATVAR.upperPos-20;
    result_ground.Sin_ground(:,i) = out.VEGETATION{1, i}.STATVAR.flux.swdn(1,1)+out.VEGETATION{1, i}.STATVAR.flux.swdn(1,2);
    result_ground.Lin_ground(:,i) = out.VEGETATION{1, i}.STATVAR.flux.irdn;
    result_ground.Sout_ground(:,i) = out.STRATIGRAPHY{1, i}{1, 1}.STATVAR.Sout;
    end
end

for o = 3:8 
result_ground.t_ground(o,:) = result_ground.Temp_ground(o,:);
result_ground.water_ground(o,:) = result_ground.Water_ground(o,:);
result_ground.ice_ground(o,:) = result_ground.Ice_ground(o,:);
end

for i = 1:size(out.STRATIGRAPHY,2)
result_ground.transpiration(:,i) = nansum(result_ground.transpiration(:,i));
result_ground.mean(:,i) = nanmean(result_ground.t_ground(:,i));
result_ground.median(:,i) = nanmedian(result_ground.t_ground(:,i));
result_ground.min(:,i) = nanmin(result_ground.t_ground(:,i));
result_ground.max(:,i) = nanmax(result_ground.t_ground(:,i));

result_ground.mean_water(:,i) = nanmean(result_ground.water_ground(:,i));
result_ground.median_water(:,i) = nanmedian(result_ground.water_ground(:,i));
result_ground.min_water(:,i) = nanmin(result_ground.water_ground(:,i));
result_ground.max_water(:,i) = nanmax(result_ground.water_ground(:,i));

result_ground.mean_ice(:,i) = nanmean(result_ground.ice_ground(:,i));
result_ground.median_ice(:,i) = nanmedian(result_ground.ice_ground(:,i));
result_ground.min_ice(:,i) = nanmin(result_ground.ice_ground(:,i));
result_ground.max_ice(:,i) = nanmax(result_ground.ice_ground(:,i));
end

% plot(result_ground.x_datetime,result_ground.transpiration(1,:))

clear zL*
clear maxALT
ts = out.TIMESTAMP;

zsoil = grid.GRID./2;
Z = result_ground.Temp_ground;
diagTL = 0;
[zL1Tpos_ub,zL1Tpos_lb,zL2Tpos_ub,zL2Tpos_lb,zL3Tpos_ub,zL3Tpos_lb] = find_thawedLayers(zsoil,Z,diagTL,ts);

ts_str = datestr(ts')
ts_dT = datetime(ts_str)
TT_Spasskaya_ALT = timetable(ts_dT, zL1Tpos_lb',zL2Tpos_ub',zL3Tpos_lb');

maxALT = nanmax(zL1Tpos_lb(:,:));
meanALT = nanmean(zL1Tpos_lb(:,:));

AL_lower = zL1Tpos_lb';
AL_lower_double = num2cell(AL_lower);
zsoil_double = num2cell(zsoil);

% find the cell in zsoil which equals AL_lower and assign that number to AL_cell
match = cellfun(@(c) find(c == zsoil), AL_lower_double, 'uniform', false);
match_num = cell2mat(match);

result_ground.Water_ground_m = result_ground.Water_ground*0.05;
result_ground.Ice_ground_m = result_ground.Ice_ground*0.05;

for i = 1:size(out.STRATIGRAPHY,2)
        for o = match_num(i)
        result_ground.water_ALT(1,i) = nansum(result_ground.Water_ground_m(1:o,i));
        result_ground.ice_ALT(1,i) = nansum(result_ground.Ice_ground_m(1:o,i));
        end
end

% plot(result_ground.x_datetime, result_ground.water_ALT)

% clear('modeled_daily_TT');
% clear('modeled')
% modeled = table2timetable(testvegetationsnow111TableLongSpasskaya1);
% modeled_daily = retime(modeled, 'daily');
% modeled_daily_TT = timetable2table(modeled_daily);
% writetable(modeled_daily_TT,[run_name '_TableLong_Spasskaya_daily.xlsx'],'WriteRowNames',true);

clear TT_Spasskaya
clear TT_all_Spasskaya
% Save
TT_Spasskaya = timetable(result_ground.x_datetime, result_ground.rn_ground', result_ground.qh_veg', result_ground.qe_veg', result_ground.Lout_ground', result_ground.Lout_CanopyTop', result_ground.Tair_CanopyTop', result_ground.Tair_BelowCanopy', result_ground.mean', result_ground.mean_water', result_ground.mean_ice', result_ground.snow', result_ground.Sin_ground',result_ground.Lin_ground', result_ground.Sout_ground', result_ground.transpiration(1,:)', zL1Tpos_lb', result_ground.water_ALT', result_ground.ice_ALT', 'VariableNames',{'netRadiationGround', 'sensibleHF', 'latentHF', 'Lout_ground', 'Lout_above','Tair_above', 'Tair_below', 'SoilTemperature', 'SoilWater', 'SoilIce', 'SnowCover', 'Sin_ground', 'Lin_ground', 'Albedo', 'Transpiration','ALT','Water_ALT','Ice_ALT'});
TT_Spasskaya_all = timetable2table(TT_Spasskaya);

writetable(TT_Spasskaya_all,[run_name '_TableLong_Chukotka.xlsx'],'WriteRowNames',true);

mo = month(result_ground.x_datetime);   %get month numbers
% isSummer = ismember(mo, [5,6,7,8,9]);   %here you define the seasons by month
% isWinter = ismember(mo, [10,11,12,1,2,3,4]);
isSummer = ismember(mo, [7,8,9]);   %here you define the seasons by month
isWinter = ismember(mo, [10,11,12,1,2,3,4,5,6]);

meanT_snowCovered = nanmean(result_ground.mean(:,isWinter'));
stdT_snowCovered = nanstd(result_ground.mean(:,isWinter'));
minT_snowCovered = nanmin(result_ground.mean(:,isWinter'));
maxT_snowCovered = nanmax(result_ground.mean(:,isWinter'));

meanT_snowFree = nanmean(result_ground.mean(:,isSummer'));
stdT_snowFree = nanstd(result_ground.mean(:,isSummer'));
minT_snowFree = nanmin(result_ground.mean(:,isSummer'));
maxT_snowFree = nanmax(result_ground.mean(:,isSummer'));

maxT = nanmax(result_ground.mean(:,:));
stdT = nanstd(result_ground.mean(:,:));
meanT = nanmean(result_ground.mean(:,:));
minT = nanmin(result_ground.mean(:,:));

meanW_snowCovered = nanmean(result_ground.mean_water(:,isWinter'));
stdW_snowCovered = nanstd(result_ground.mean_water(:,isWinter'));
minW_snowCovered = nanmin(result_ground.mean_water(:,isWinter'));
maxW_snowCovered = nanmax(result_ground.mean_water(:,isWinter'));

meanW_snowFree = nanmean(result_ground.mean_water(:,isSummer'));
stdW_snowFree = nanstd(result_ground.mean_water(:,isSummer'));
minW_snowFree = nanmin(result_ground.mean_water(:,isSummer'));
maxW_snowFree = nanmax(result_ground.mean_water(:,isSummer'));

maxW = nanmax(result_ground.mean_water(:,:));
stdW = nanstd(result_ground.mean_water(:,:));
meanW = nanmean(result_ground.mean_water(:,:));
minW = nanmin(result_ground.mean_water(:,:));

TT_snow_forest = timetable(result_ground.x_datetime, result_ground.snow', 'VariableNames',{'Modelled'});
TT_snow_forest{:,1}(TT_snow_forest{:,1}==100) = 0;
maxSnow = nanmax(TT_snow_forest.Modelled);

PlantWater_av = nansum(result_ground.water_ALT);

end